﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using System;
using System.Collections.Generic;

namespace jamProject
{
    /// <summary>
    /// This is the main type for your game.
    /// </summary>
    public class Game1 : Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        public float GameSpeed = 1;

        public Fish pl;
        public List<Fish> anti = new List<Fish>();
        float timeNewFish;

        public float fClrText;
        string[] text = new string[]
        {
            "THIS GAME",
            "ABOUT FISH",
            "FISH FROM river WIASS",

        };

        public Color clrBackgr;

        Texture2D txtDriver;
        Texture2D txtFish;
        Texture2D txtBolls;
        Texture2D txtWave;
        Texture2D viborClr;
        Texture2D[] txtTrava = new Texture2D[4];
        Texture2D[] Text = new Texture2D[6];

        SpriteFont Verdana24;

        public int[,] grid;
        public int xGrid, yGrid;

        float timeNewBolls , timeNewWave = 20;
        public List<Bolls> lBolls = new List<Bolls>();
        public List<Wave> lWave = new List<jamProject.Wave>();
        public List<Vector4> lPosKyst = new List<Vector4>();

        public List<Vector3> lHlam = new List<Vector3>();

        float timeNewTrava;
        public List<Vector3> lPosTrava = new List<Vector3>();

        float timeDriver;
        public List<Vector2> lPosDriver = new List<Vector2>();

        public Color[] clrsBackgr = new Color[]
        {
            new Color(236,171,29),
            new Color(184,126,187),
            new Color(221,80,63)
        };
        public int modeClr = -1;

        Wave wave;
        List<AnimBack> lAB = new List<AnimBack>();

        float[] bg = new float[4];
        Texture2D[] txtBc = new Texture2D[4];


        public bool Start;
        internal float allVolume = 1;

        float Restart;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        protected override void Initialize()
        {
            graphics.PreferredBackBufferWidth = 1366;
            graphics.PreferredBackBufferHeight = 768;
            xGrid = (int)(graphics.PreferredBackBufferWidth / 10f);
            yGrid = (int)(graphics.PreferredBackBufferHeight / 10f);

            graphics.IsFullScreen = true;
            graphics.ApplyChanges();

            grid = new int[xGrid, yGrid];

            base.Initialize();

        }

        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.

            spriteBatch = new SpriteBatch(GraphicsDevice);

            txtBolls = Content.Load<Texture2D>("Bolls");
            txtFish = Content.Load<Texture2D>("Fish");
            viborClr = Content.Load<Texture2D>("viborClr");
            txtWave = Content.Load<Texture2D>("Wave");

            Verdana24 = Content.Load<SpriteFont>("Verdana24");
            txtDriver = Content.Load<Texture2D>("Driver");


            for (int i = 0; i < 4; i++)
            {
                string puth = "bc" + i.ToString();
                txtBc[i] = Content.Load<Texture2D>(puth);

                puth = "trava/" + (i + 2).ToString();
                txtTrava[i] = Content.Load<Texture2D>(puth);
            }

            for (int i = 0; i < 6; i++)
            {
                string puth = "Text/" + i.ToString();
                Text[i] = Content.Load<Texture2D>(puth);
            }

            SoundsPlayer.SoundsPlayerLoad(this);
            // TODO: use this.Content to load your game content here

            pl = new Fish(txtFish, viborClr, new Vector2(0, 768 / 2f), 0);

            for (int i = 0; i < 10; i++)
                lPosKyst.Add(new Vector4(new Vector2(i * 1366 / 10f, 768), new Random().Next(10, 20) / 10f, 0));

            clrBackgr = Color.LightGray;

            lAB.Add(new AnimBack(Vector2.Zero, new Vector2(1), 1));

            for (int i = -3; i <= 3; i++)
                lAB.Add(new AnimBack(new Vector2(0, -768 / 2f * i), new Vector2(0.25f + i * 0.05f), 0.5f + i / 3));
        }

        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        public void UpdateGrid()
        {
            grid = new int[xGrid, yGrid];



        }

        void startText(GameTime gameTime)
        {
            if (fClrText < 1) fClrText += 0.005f;
            else fClrText = 1;
        }

        protected override void Update(GameTime gameTime)
        {
            startText(gameTime);

            UpdateGrid();

            if (timeNewBolls > 0)
                timeNewBolls -= (float)gameTime.ElapsedGameTime.TotalSeconds * GameSpeed;
            else
            {
                timeNewBolls = 0.2f;
                lBolls.Add(new Bolls(txtBolls, Vector2.Zero, Vector2.Zero, Vector2.Zero));
            }

            if (Start)
                if (timeNewFish > 0)
                    timeNewFish -= (float)gameTime.ElapsedGameTime.TotalSeconds * GameSpeed;
                else
                {
                    timeNewFish = 7.5f;

                    Random r = new Random();

                    for (int i = 0; i < 7; i++)
                        //if (i != r)
                        anti.Add(new Fish(txtFish, viborClr, new Vector2(-500 + r.Next(-250, 250), 768 - 64 - 192 * i), 1));
                }

            if (Start)
                if (timeNewWave > 0)
                    timeNewWave -= (float)gameTime.ElapsedGameTime.TotalSeconds * GameSpeed;
                else
                {
                    timeNewWave = 10;

                    lWave.Add(new Wave(this, txtWave, 0));
                }

            if (timeNewTrava <= 0)
            {
                lPosTrava.Add(new Vector3(1400, 768, new Random().Next(4)));
                timeNewTrava = new Random().Next(5, 10);
            }
            else timeNewTrava -= (float)gameTime.ElapsedGameTime.TotalSeconds * GameSpeed;

            if (timeDriver <= 0)
            {
                lPosDriver.Add(new Vector2(1400, -250));
                timeDriver = new Random().Next(10, 20);
            }
            else timeDriver -= (float)gameTime.ElapsedGameTime.TotalSeconds * GameSpeed;

            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed || Keyboard.GetState().IsKeyDown(Keys.Escape))
                Exit();
            {
                pl.UpdatePlayer(this);
                int x = (int)((pl.pos.X  + 110)/ 10f);
                int y = (int)((pl.pos.Y + 60) / 10f);

                for (int y1 = y - 1; y1 <= y + 1; y1++)
                    if (x >= 0 && x < xGrid && y1 >= 0 && y1 < yGrid)
                        grid[x, y1] = 10;


                x = (int)((pl.pos.X - 75) / 10f);
                for (int y1 = y - 1; y1 <= y + 1; y1++)
                    if (x >= 0 && x < xGrid && y1 >= 0 && y1 < yGrid)
                        grid[x, y1] = 10;

                if (pl.hp <= 0)
                    if (Restart < 1) Restart += 0.05f;
                    else
                    {
                        Restart = 1;

                        if (pl.pos.Y <= 40)
                            if (Mouse.GetState().LeftButton == ButtonState.Pressed)
                            {
                                anti.Clear();
                                lWave.Clear();
                                lBolls.Clear();

                                timeNewWave = 20;
                                timeNewFish = 12.5f;

                                pl.hp = 100;
                                pl.Score = 0;
                                pl.pos = new Vector2(200, 768 / 2f);

                                Restart = 0;
                            }
                    }
            }

            for (int i = 0; i < lPosTrava.Count; i++)
            {
                lPosTrava[i] += new Vector3(-25, 0, 0) * GameSpeed;

                if (lPosTrava[i].X <= -1366)
                {
                    lPosTrava.RemoveAt(i);
                    i--;
                }
            }

            for (int i = 0; i < lPosDriver.Count; i++)
            {
                lPosDriver[i] += new Vector2(-7.5f, +5) * GameSpeed;

                if (lPosDriver[i].Y > 768 * 3)
                {
                    lPosDriver.RemoveAt(i);
                    i--;
                }
            }

            for (int i = 0; i < anti.Count; i++)
            {
                anti[i].UpdateAnti(this, gameTime, i);

                int x = (int)((anti[i].pos.X + 110) / 10f);
                int y = (int)((anti[i].pos.Y + 60) / 10f);

                for (int y1 = y - 1; y1 <= y + 1; y1++)
                    if (x >= 0 && x < xGrid && y1 >= 0 && y1 < yGrid)
                    {
                        if (anti[i].hp > 0)
                            if (grid[x, y1] == 10)
                            {
                                pl.hp = 0;
                                anti[i].openRot = true;
                                anti[i].rotTime = 3;
                            }

                        grid[x, y1] = 11 + i;


                    }


                if (anti[i].pos.X > 1500)
                {
                    anti.RemoveAt(i);
                    i--;
                }
            }

            for (int i = 0; i < lWave.Count; i++)
            {

                lWave[i].Update(this);

                if (lWave[i].pos.X + 20 <= pl.pos.X && lWave[i].pos.X + 300 >= pl.pos.X)
                {
                    if (lWave[i].modeClr != modeClr)
                        pl.hp = 0;


                }

                int x = (int)(lWave[i].pos.X/ 10f);
                int y = (int)(lWave[i].pos.Y / 10f);

                for (int x1 = x - 6; x1 <= x; x1++)
                    for (int y1 = 0; y1 < yGrid; y1++)
                        if (x1 >= 0 && x1 < xGrid && y1 >= 0 && y1 < yGrid)
                            if (grid[x1, y1] >= 11)
                            {
                                anti[grid[x1, y1] - 11].hp = 0;
                            }

                if (lWave[i].pos.X > 1500)
                {
                    lWave.RemoveAt(i);
                    i--;
                }
            }

            for (int i = 0; i < lBolls.Count; i++)
            {
                lBolls[i].Update(this);

                if (lBolls[i].pos.X < 20)
                {
                    lBolls.RemoveAt(i);
                    i--;
                }
                else if (lBolls[i].newBonus)
                {
                    for (int n = 0; n < 5; n++)
                    {
                        Random r1= new Random(n * i);
                        lBolls.Add(new Bolls(txtBolls, lBolls[i].pos, new Vector2(r1.Next(-10, 10), r1.Next(-10, 10)) / 20f, lBolls[i].size / 2f));
                    }

                    lHlam.Add(new Vector3(lBolls[i].pos, lBolls[i].modeForPl));

                    lBolls.RemoveAt(i);
                    i--;
                }
                else if (lBolls[i].newBolls)
                {
                    for (int n = 0; n < 5; n++)
                    {
                        Random r1= new Random(n * i);
                        lBolls.Add(new Bolls(txtBolls, lBolls[i].pos, new Vector2(r1.Next(-10, 10), r1.Next(-10, 10)) / 20f, lBolls[i].size / 2f));
                    }



                    lBolls.RemoveAt(i);
                    i--;
                }

            }

            for (int i = 0; i < lHlam.Count; i++)
            {
                lHlam[i] += new Vector3(-5, 2.5f * GameSpeed, 0);

                if (lHlam[i].Y >= 800)
                {
                    lHlam.RemoveAt(i);
                    i--;
                }
                else
                {
                    int x = (int)((lHlam[i].X ) / 10f);
                    int y = (int)((lHlam[i].Y) / 10f);

                    for (int x1 = x - 2; x1 <= x + 2; x1++)
                        for (int y1 = y - 2; y1 <= y + 2; y1++)
                            if (x1 >= 0 && x1 < xGrid && y1 >= 0 && y1 < yGrid)
                                grid[x1, y1] = 20 + i;
                }

            }

            SoundsPlayer.PlayAllS(this, gameTime);
            base.Update(gameTime);
        }

        public class AnimBack
        {
            float fX = 1400; int iB = 0; Color clrFish = Color.White; Vector2 randomPos;
            float newBoll;

            float f;
            Vector2 pos, size;
            public AnimBack(Vector2 pos, Vector2 size, float F)
            {
                this.pos = pos;
                this.size = size;
                f = F;
            }

            public void DrawAnimBack(Game1 game, GameTime gamTime)
            {
                if (fX > -100 - this.pos.X)
                {
                    fX -= 10 * size.X * game.GameSpeed;
                }
                else
                {
                    iB = new Random().Next(3);
                    fX = 2000 + new Random().Next(1000);
                    clrFish = game.pl.clrs[new Random().Next(5)];
                    randomPos = new Vector2(new Random().Next(-1366 / 2, 1366 / 2), 0);
                }

                float f = fX / 1500f;

                Vector2 pos = new Vector2(fX, 768 -64 * f + 128 * f) + randomPos + this.pos ;

                if (fX > -100 && (size.X > 0.5f))
                    if (newBoll <= 0)
                    {
                        game.lBolls.Add(new Bolls(game.txtBolls, pos, new Vector2(0, 20), Vector2.Zero));
                        newBoll = 20;
                    }
                    else newBoll--;

                float depth = 0.7f;
                if (size.X < 0.5f)
                    depth = 0.4f;

                game.spriteBatch.Draw(game.txtFish, pos, new Rectangle(256, 256, 256, 256), new Color(clrFish, 1f) * this.f, -((float)Math.PI / 2 + 4) * f, new Vector2(100, 128), 1.5f * size, SpriteEffects.None, depth);

                game.spriteBatch.Draw(game.txtBolls, pos, new Rectangle(0, 64 * (iB + 1), 64, 64), new Color(Color.White, 1f) * this.f, -((float)Math.PI / 2 + 4) * f, new Vector2(-80 * 1.5f, -20), 1.5f * size, SpriteEffects.None, depth - 0.1f);
            }
        }

        protected override void Draw(GameTime gameTime)
        {
            clrBackgr = Color.DarkGray;

            if (modeClr >= 0)
                clrBackgr = new Color(clrsBackgr[modeClr] * 0.9f, 255);

            GraphicsDevice.Clear(clrBackgr);

            spriteBatch.Begin(SpriteSortMode.FrontToBack, BlendState.AlphaBlend);

            pl.Draw(this, gameTime, spriteBatch, 0.5f);

            pl.DrawChangeClr(this, spriteBatch);

            //if (iClick < 8)
            //    spriteBatch.DrawString(Verdana24, text[pl.iClick / 2], new Vector2(1366 / 2, 100), Color.Black * fClrText, 0, new Vector2(Verdana24.MeasureString(text[pl.iClick / 2]).X / 2, 0), 2, SpriteEffects.None, 0.9f);
            if (pl.iClick < 8)
            {
                float iClick = pl.iClick;

                if (pl.iClick >= 6) iClick = 5;

                spriteBatch.Draw(Text[(int)(iClick / 2f)], new Vector2(1366 / 2, 100), new Rectangle(0, 0, Text[(int)(iClick / 2f)].Width, Text[(int)(iClick / 2f)].Height), Color.White, 0, new Vector2(Text[(int)(iClick / 2f)].Width, Text[(int)(iClick / 2f)].Height) / 2f, 1.5f, SpriteEffects.None, 0.99f);

            }

            spriteBatch.Draw(Text[3], new Vector2(1366 / 2, 768 / 2f - 100), new Rectangle(0, 0, Text[3].Width, Text[3].Height), Color.White * Restart, 0, new Vector2(Text[3].Width, Text[3].Height) / 2f, 1.5f, SpriteEffects.None, 0.99f);

            if (pl.hp > 0)
                if (pl.iClick < 10)
                    spriteBatch.Draw(Text[4], new Vector2(1366 / 2, 768 - 150), new Rectangle(0, 0, Text[4].Width, Text[4].Height), Color.White, 0, new Vector2(Text[4].Width, Text[4].Height) / 2f, 1f, SpriteEffects.None, 0.99f);
                else if (pl.Score >= 10 && pl.iClick < 20)
                    spriteBatch.Draw(Text[5], new Vector2(1366 / 2, 768 - 150), new Rectangle(0, 0, Text[5].Width, Text[5].Height), Color.White, 0, new Vector2(Text[5].Width, Text[5].Height) / 2f, 1f, SpriteEffects.None, 0.99f);


            //string res = "FISH IS DEAD";
            //spriteBatch.DrawString(Verdana24, res, new Vector2(1366 / 2, 100), Color.Black * Restart, 0, new Vector2(Verdana24.MeasureString(res).X / 2, 0), 2, SpriteEffects.None, 0.99f);
            //res = "Right click to Restart";
            //spriteBatch.DrawString(Verdana24, res, new Vector2(1366 / 2, 155), Color.Black * Restart, 0, new Vector2(Verdana24.MeasureString(res).X / 2, 0), 2, SpriteEffects.None, 0.99f);

            for (int i = 0; i < anti.Count; i++)
                anti[i].Draw(this, gameTime, spriteBatch, 0.45f);

            for (int i = 0; i < lBolls.Count; i++)
                lBolls[i].Draw(this, spriteBatch);

            for (int i = 0; i < lWave.Count; i++)
                lWave[i].Draw(this, spriteBatch);

            for (int i = 0; i < lHlam.Count; i++)
                spriteBatch.Draw(txtBolls, new Vector2(lHlam[i].X, lHlam[i].Y), new Rectangle(0, 64 * (int)lHlam[i].Z, 64, 64), Color.White, 0, new Vector2(32, 32), 1, SpriteEffects.None, 0.35f);

            //for (int i = 0; i < lPosKyst.Count; i++)
            //    spriteBatch.Draw(txtTrava, new Vector2(lPosKyst[i].X, lPosKyst[i].Y), new Rectangle(0, 0, txtTrava.Width, txtTrava.Height), Color.White, 0, new Vector2(txtTrava.Width / 2f, txtTrava.Height), lPosKyst[i].Z, SpriteEffects.None, 0.8f + 0.01f * i);

            string text1 = "x" + pl.Score.ToString();
            spriteBatch.Draw(txtBolls, new Vector2(1366 - 160 - 538 * Restart, 110 + 354 * Restart), new Rectangle(0, 128, 64, 64), Color.White, 0, new Vector2(32, 32), 1 + Restart, SpriteEffects.None, 0.992f);
            spriteBatch.Draw(txtBolls, new Vector2(1366 - 160 + 20 - 538 * Restart, 110 + 10 + 354 * Restart), new Rectangle(0, 64, 64, 64), Color.White, 0, new Vector2(32, 32), 1 + Restart, SpriteEffects.None, 0.993f);
            spriteBatch.Draw(txtBolls, new Vector2(1366 - 160 - 538 * Restart, 120 + 354 * Restart), new Rectangle(0, 192, 64, 64), Color.White, 0, new Vector2(32, 32), 1 + Restart, SpriteEffects.None, 0.991f);
            spriteBatch.DrawString(Verdana24, text1, new Vector2(1366 - 90 - 478 * Restart, 100 + 334 * Restart), Color.White, 0, new Vector2(Verdana24.MeasureString(text1).X / 2f, 0), 1 + Restart, SpriteEffects.None, 0.995f);

            //for (int i = 0; i < bg.Length; i++)
            //{
            //    bg[i] -= 5 * (float)(1 + i) / (1 + bg.Length) * 5;

            //    if (bg[i] < -txtBc[i].Width / 2f)
            //        bg[i] = txtBc[i].Width;

            //    spriteBatch.Draw(txtBc[i], new Vector2(bg[i], 0), new Rectangle(0, 0, txtBc[i].Width, txtBc[i].Height), clrBackgr, 0, Vector2.Zero, 1, SpriteEffects.None, (float)i / bg.Length);
            //    spriteBatch.Draw(txtBc[i], new Vector2(bg[i] + txtBc[i].Width, 0), new Rectangle(0, 0, txtBc[i].Width, txtBc[i].Height), clrBackgr, 0, Vector2.Zero, 1, SpriteEffects.None, (float)i / bg.Length);
            //}
            for (int i = 0; i < bg.Length; i++)
            {
                float s = 1;
                if (i == 1) s = 1.5f;
                //int i = 0;
                bg[i] -= 1.25f * (i + 1) / (bg.Length + 1) * 5 * 2 * GameSpeed;
                if (bg[i] < -txtBc[i].Width)
                    bg[i] = 0;
                spriteBatch.Draw(txtBc[i], new Vector2(bg[i], 768), new Rectangle(0, 0, txtBc[i].Width, txtBc[i].Height), clrBackgr, 0, new Vector2(0, txtBc[i].Height), new Vector2(1, s), SpriteEffects.None, 0.2f + 0.125f * i);
                spriteBatch.Draw(txtBc[i], new Vector2(bg[i] + txtBc[i].Width, 768), new Rectangle(0, 0, txtBc[i].Width, txtBc[i].Height), clrBackgr, 0, new Vector2(0, txtBc[i].Height), new Vector2(1, s), SpriteEffects.None, 0.2f + 0.125f * i);
                spriteBatch.Draw(txtBc[i], new Vector2(bg[i] + txtBc[i].Width * 2, 768), new Rectangle(0, 0, txtBc[i].Width, txtBc[i].Height), clrBackgr, 0, new Vector2(0, txtBc[i].Height), new Vector2(1, s), SpriteEffects.None, 0.2f + 0.125f * i);
            }

            for (int i = 0; i < lPosTrava.Count; i++)
                spriteBatch.Draw(txtTrava[(int)lPosTrava[i].Z], new Vector2((int)lPosTrava[i].X, txtTrava[(int)lPosTrava[i].Z].Height), new Rectangle(0, 0, txtTrava[(int)lPosTrava[i].Z].Width, txtTrava[(int)lPosTrava[i].Z].Height), Color.Black * 0.75f, 0, new Vector2(0, txtTrava[(int)lPosTrava[i].Z].Height), 0.75f, SpriteEffects.None, 0.95f);

            for (int i = 0; i < lPosDriver.Count; i++)
                spriteBatch.Draw(txtDriver, lPosDriver[i], new Rectangle(0, 0, txtDriver.Width, txtDriver.Height), clrBackgr, 0, new Vector2(0, txtDriver.Height + 20), 0.25f, SpriteEffects.None, 0.25f);

            //

            for (int i = 0; i < lAB.Count; i++)
                lAB[i].DrawAnimBack(this, gameTime);


            spriteBatch.End();
            // TODO: Add your drawing code here

            base.Draw(gameTime);
        }
    }
}
